﻿;{-----------------------------------------------------------------------------
; »»» Project  : PureMonitor for Windows
; »»» File     : PureMonitor.pb
; »»» Author   : George Bisonte
; »»» Version  : 1.0
; »»» Compiler : PureBasic 5.11 (Windows - x86)
; »»» created  : 13.02.2013 - 01:49
; »»» LastMod  : 30.04.2013 - 13:43
; »»» Flags    : [ ]ASM       [ ]Unicode  [x]Thread  [x]XP-Skin
; »»»            [ ]AdminMode [ ]Usermode [ ]OnError [ ]Purifier
; -----------------------------------------------------------------------------
  CompilerIf #PB_Compiler_IsMainFile
    EnableExplicit
  CompilerEndIf
;}-----------------------------------------------------------------------------
  #APP_FULLNAME = "PureMonitor for Windows"
  #APP_NAME     = "PureMonitor"
  #APP_AUTHOR   = "George Bisonte"
  #APP_VERSION  = "1.0"
  #APP_REVISION = 1.000
; -----------------------------------------------------------------------------
; ### Deklaration
; -----------------------------------------------------------------------------
Macro ShowResourceViewer()
  ; Dies sollte in eine Resident (.res) Datei
  RunProgram(#PB_Compiler_Home + "PureMonitor.exe", Str(GetCurrentProcessId_()), "")
EndMacro
;
#GR_GDIOBJECTS        = 0
#GR_GDIOBJECTS_PEAK   = 2
#GR_USEROBJECTS       = 1
#GR_USEROBJECTS_PEAK  = 4
;
#CPU_Timer            = 1000 ; 1000ms = 1s
#CPU_Timer_Event      = 1
#Log_Timer            = 2
;
; You can include your own sound...
#INCLUDE_SOUNDFILE    = "sound.wav"
;
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  #Processor = "x64"
CompilerElse
  #Processor = "x86"
CompilerEndIf
;
Prototype GetProcessMemoryInfo_Prototype(hProcess, Address, Size)
;
Structure task_monitoring_struct
  PID.i
  Name.s
  Path.s
  CPU_Load.d
  MemUsage.i
  Halt.i
  Thread.i
  icon.i
EndStructure
;
Structure PROCESS_MEMORY_COUNTERS
  cb.l
  PageFaultCount.l
  PeakWorkingSetSize.i
  WorkingSetSize.i
  QuotaPeakPagedPoolUsage.i
  QuotaPagedPoolUsage.i
  QuotaPeakNonPagedPoolUsage.i
  QuotaNonPagedPoolUsage.i
  PagefileUsage.i
  PeakPagefileUsage.i
EndStructure
;
Structure PLI_ProcessInfo
  Name.s
  Path.s
  PID.i
  ParentID.i
  ThreadsCnt.i
  PriorityClass.i
  Icon.i
  WorkingSetSize.i
EndStructure
;
Structure struct_puremon_datas
  
  PID.i
  Name.s
  
  CPUName.s
  CPULoad.d
  MaxCPULoad.d
  
  Ram.i
  MaxRam.i
  TotRam.i
  
  ProcHandles.i
  GDIHandles.i
  GDIPeak.i
  UserHandles.i
  UserPeak.i
  
  Icon.i
  Processor.i
  
  Sound.i
  Font.i
  Window.i
  WColor.i
  
  G_Title.i
  G_CPU.i
  G_RAM.i
  G_Handles.i
  G_Options.i
  
  RAM_LOGO.i
  CPU_LOGO.i
  PB_Logo.i
  Hnd_Logo.i
  CheckLogo.i
  UncheckLogo.i
  
EndStructure
;
Structure struct_puremon_prefs
  
  WinSize.RECT
  VAlert.i
  AAlert.i
  TresholdRam.i
  TresholdCPU.i
  SoundFile.s
  Volume.i
  LogFile.i
  LogEvery.i  
  
EndStructure
;
InitSound()
;
Global PM.struct_puremon_datas
Global PP.struct_puremon_prefs
;
Import "Kernel32.lib"
  GetProcessHandleCount(hProcess, pHandles.l)
EndImport
;
; -----------------------------------------------------------------------------
; ### Prozeduren
; -----------------------------------------------------------------------------
Procedure.s GetCPUName()
  
  ; Gibt den Namen der CPU zurück / Returns the name of the CPU
  ; Author : ts-soft ?
  ; Link   : http://www.purebasic.fr/english/viewtopic.php?p=190234#p190234
  
  Protected sBuffer.s
  Protected Zeiger1.l, Zeiger2.l, Zeiger3.l, Zeiger4.l
  
  !MOV eax, $80000002
  !CPUID
  ; the CPU-Name is now stored in EAX-EBX-ECX-EDX
  !MOV [p.v_Zeiger1], EAX ; move eax to the buffer
  !MOV [p.v_Zeiger2], EBX ; move ebx to the buffer
  !MOV [p.v_Zeiger3], ECX ; move ecx to the buffer
  !MOV [p.v_Zeiger4], EDX ; move edx to the buffer
  
  ;Now move the content of Zeiger (4*4=16 Bytes to a string
  sBuffer = PeekS(@Zeiger1, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger2, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger3, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger4, 4, #PB_Ascii)
  
  ;Second Part of the Name
  !MOV eax, $80000003
  !CPUID
  ; the CPU-Name is now stored in EAX-EBX-ECX-EDX
  !MOV [p.v_Zeiger1], EAX ; move eax to the buffer
  !MOV [p.v_Zeiger2], EBX ; move ebx to the buffer
  !MOV [p.v_Zeiger3], ECX ; move ecx to the buffer
  !MOV [p.v_Zeiger4], EDX ; move edx to the buffer
  
  ;Now move the content of Zeiger (4*4=16 Bytes to a string
  sBuffer + PeekS(@Zeiger1, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger2, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger3, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger4, 4, #PB_Ascii)
  
  
  ;Third Part of the Name
  !MOV eax, $80000004
  !CPUID
  ; the CPU-Name is now stored in EAX-EBX-ECX-EDX
  !MOV [p.v_Zeiger1], EAX ; move eax to the buffer
  !MOV [p.v_Zeiger2], EBX ; move ebx to the buffer
  !MOV [p.v_Zeiger3], ECX ; move ecx to the buffer
  !MOV [p.v_Zeiger4], EDX ; move edx to the buffer
  
  ;Now move the content of Zeiger (4*4=16 Bytes to a string
  sBuffer + PeekS(@Zeiger1, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger2, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger3, 4, #PB_Ascii)
  sBuffer + PeekS(@Zeiger4, 4, #PB_Ascii)

  ProcedureReturn sBuffer
  
EndProcedure
Procedure   GetProgramID()
  
  ; Holt sich die PID aus dem Programmaufruf
  
  Protected P.s = ProgramParameter()
  PM\PID = Val(P)
  ProcedureReturn Val(P)
  
EndProcedure
Procedure   GetHandleCounters()
  
  ; Gibt die Anzahl der geoeffneten Handles zurück
  
  Protected pHnd, dwDesiredAccess, hCount
  
  pHnd = OpenProcess_(#PROCESS_QUERY_INFORMATION, #False, PM\PID)
  
  If pHnd
    
    GetProcessHandleCount(pHnd,@hCount)
    PM\ProcHandles = hCount
    
    PM\GDIHandles = GetGuiResources_(pHnd, #GR_GDIOBJECTS)
    PM\UserHandles = GetGuiResources_(pHnd, #GR_USEROBJECTS)
    If OSVersion() >= #PB_OS_Windows_7
      PM\GDIPeak = GetGuiResources_(pHnd, #GR_GDIOBJECTS_PEAK)
      PM\UserPeak = GetGuiResources_(pHnd, #GR_USEROBJECTS_PEAK)
    EndIf

    CloseHandle_(pHnd)
    
  EndIf
  
EndProcedure
Procedure   GetMemoryUsage(PID)
  
  ; Gibt die Bytes des benutzen Speichers zurück
  ; Author : netmaestro
  
  Protected hProcess, Result = 0, PSAPI_LIB
  Protected pmc.PROCESS_MEMORY_COUNTERS
  Protected GetProcessMemoryInfo_.GetProcessMemoryInfo_Prototype
  
  If PID
    
    PSAPI_LIB = OpenLibrary(#PB_Any, "PSAPI.DLL")
    If PSAPI_LIB
      GetProcessMemoryInfo_.GetProcessMemoryInfo_Prototype = GetFunction(PSAPI_LIB,"GetProcessMemoryInfo")
      
      hProcess = OpenProcess_(  #PROCESS_QUERY_INFORMATION | #PROCESS_VM_READ, #False, PID )
      If (hProcess=0)
        ProcedureReturn 0
      EndIf
      
      If GetProcessMemoryInfo_( hProcess, @pmc, SizeOf(pmc))
        Result.i = pmc\WorkingSetSize  
      EndIf
      CloseHandle_(hProcess)
      CloseLibrary(PSAPI_LIB)
    Else
      ProcedureReturn 0  
    EndIf
    
    ProcedureReturn Result  
  EndIf

EndProcedure
Procedure   GetProcessList(List Tasks.PLI_ProcessInfo(), Icons = #False)

;###### 
;###### Author : Thorium 
;###### Quelle : http://www.purebasic.fr/german/viewtopic.php?f=11&t=12401
;###### Modifiziert von Array auf LinkList
;######

  ClearList(Tasks())

  Protected ProcessSnapHandle, ModuleSnapHandle, RetVal, i, ProcessID, ExePath, IconHandle, SystemAppIcon
  Protected ProcessEntry.PROCESSENTRY32
  Protected ModuleEntry.MODULEENTRY32
  Protected ProcessListCnt = 0
  
  ProcessEntry\dwSize = SizeOf(ProcessEntry)
  ModuleEntry\dwSize = SizeOf(ModuleEntry)

  ;laufende Prozesse ermitteln
  
  ExePath = AllocateMemory(1024)
  
  ProcessSnapHandle = CreateToolhelp32Snapshot_(#TH32CS_SNAPPROCESS,0)
  RetVal = Process32First_(ProcessSnapHandle,ProcessEntry)
   
  While RetVal = #True
    ProcessListCnt = ProcessListCnt + 1

    AddElement(Tasks())
    Tasks()\Name = PeekS(@ProcessEntry\szExeFile)
    Tasks()\PID = ProcessEntry\th32ProcessID
    Tasks()\ParentID = ProcessEntry\th32ParentProcessID
    Tasks()\ThreadsCnt = ProcessEntry\cntThreads
    Tasks()\PriorityClass = ProcessEntry\pcPriClassBase
    Tasks()\WorkingSetSize = GetMemoryUsage(Tasks()\PID)
    ;Debug Tasks()\Name
    If ProcessEntry\th32ProcessID <> 0
      ModuleSnapHandle = CreateToolhelp32Snapshot_(#TH32CS_SNAPMODULE,ProcessEntry\th32ProcessID)
      If ModuleSnapHandle
        If Module32First_(ModuleSnapHandle,ModuleEntry)
          Tasks()\Path = GetPathPart(Trim(PeekS(@ModuleEntry\szExePath)))
        EndIf
        CloseHandle_(ModuleSnapHandle)
      EndIf
    EndIf
    
    If Icons
      PokeS(ExePath,Tasks()\Path + Tasks()\Name)
      IconHandle = ExtractIcon_(0,ExePath,0)
      If IconHandle = 0
        IconHandle = SystemAppIcon
      EndIf
      Tasks()\Icon = IconHandle
    EndIf
    
    RetVal = Process32Next_(ProcessSnapHandle,ProcessEntry)
    
  Wend
  
  CloseHandle_(ProcessSnapHandle)
  FreeMemory(ExePath)
  
  ProcedureReturn ListSize(Tasks())
  
EndProcedure
Procedure   CheckRunningTask(PID, *p.task_monitoring_struct = 0)
  
  ; prüft ob ein Task noch läuft
  
  Protected result = #False, Snapshot, ProcessFound, Process.PROCESSENTRY32
  Process\dwSize = SizeOf(PROCESSENTRY32)
  Snapshot = CreateToolhelp32Snapshot_(#TH32CS_SNAPPROCESS, PID)
  If Snapshot
    ProcessFound = Process32First_(Snapshot, Process)
    While ProcessFound
      If Process\th32ProcessID = PID
        result = #True
        Break
      EndIf
      ProcessFound = Process32Next_(Snapshot, Process)
    Wend
    CloseHandle_(Snapshot)
  EndIf
  ProcedureReturn result
  
EndProcedure
Procedure   CPUMonitor(*p.task_monitoring_struct)
  
  ; die CPU-Ueberwachung - Thread
  
  If *p
    
    Protected NewList Tasks.PLI_ProcessInfo()
    Protected creation.FILETIME
    Protected exit.FILETIME
    Protected kernel.FILETIME
    Protected user.FILETIME
    Protected RetVal = #False
    Protected numprocs = CountCPUs()
    Protected h = OpenProcess_(#PROCESS_QUERY_INFORMATION, #False, *p\PID) 
    Protected g 
    
    GetProcessTimes_(h,@creation,@exit,@kernel,@user)
    
    Protected oldkernel=kernel\dwlowdatetime
    Protected olduser=user\dwlowdatetime
    
    Delay(500)
    
    Protected StartTime = ElapsedMilliseconds()
    
    Repeat
      If g >= 3
        
        If CheckRunningTask(*p\PID) = #False
          *p\Halt = 1
          Break
        EndIf
        g = 0
        
      EndIf
      g + 1
      
      If *p\Halt = 0
        If ElapsedMilliseconds() - StartTime >= 1000
          If *p\PID
            ;h = OpenProcess_(#PROCESS_QUERY_INFORMATION, #False, *p\PID) 
            GetProcessTimes_(h,@creation,@exit,@kernel,@user)
            *p\CPU_Load = ((((user\dwlowdatetime-olduser)+(kernel\dwlowdatetime-oldkernel))/1000)/100)/numprocs
            olduser=user\dwlowdatetime
            oldkernel=kernel\dwlowdatetime
            *p\MemUsage = GetMemoryUsage(*p\PID)
            StartTime = ElapsedMilliseconds()
            ;CloseHandle_(h)
          Else
            *p\Halt = 1
            Break
          EndIf
        Else
          Delay(500)
        EndIf
      Else
        Break
      EndIf
      
    ForEver    
    
  EndIf
    
EndProcedure
Procedure   TaskMonitorOn(PID)
  
  ; Startet die Task-Ueberwachung -> Thread
  
  Protected *p.task_monitoring_struct = AllocateMemory(SizeOf(task_monitoring_struct))
  Protected NewList Tasks.PLI_ProcessInfo()
  Protected RetVal = #False
  
  If *p
    If GetProcessList(Tasks(), #True)
      ForEach Tasks()
        If Tasks()\PID = PID
          Debug Tasks()\Name
          *p\Halt = 0
          *p\Name = Tasks()\Name
          *p\PID  = Tasks()\PID
          *p\Path = Tasks()\Path
          *p\icon = Tasks()\Icon
          RetVal = #True
          Break
        EndIf
        DestroyIcon_(Tasks()\Icon)
      Next
    EndIf
    
    If RetVal = #False
      FreeMemory(*p)
      FreeList(Tasks())
      ProcedureReturn #False
    Else
      PM\Name = *p\Name
      PM\Icon = *p\icon
      *p\Thread = CreateThread(@CPUMonitor(),*p)
      ProcedureReturn *p
    EndIf
    
  EndIf

  ProcedureReturn #False
  
EndProcedure
Procedure   TaskMonitorOff(*p.task_monitoring_struct)
  
  ; Beendet den Taskueberwachungs-Thread
  
  If *p
    If *p\Thread
      *p\Halt = 1
      WaitThread(*p\Thread)
      FreeMemory(*p)
    EndIf    
  EndIf
    
EndProcedure
Procedure   GetTaskMem(*p.task_monitoring_struct)
  
  ; Gibt den benutzen Speicher zurück wenn Thread laeuft
  Protected Result = 0
  
  If *p
    If *p\Thread
      Result = *p\MemUsage
      PM\Ram = Result
    EndIf
  EndIf
  
  ProcedureReturn Result
  
EndProcedure
Procedure.d GetCPULoad(*p.task_monitoring_struct)
  
  ; Gibt die CPU Auslastung zurueck, wenn Task laeuft
  
  Protected Result.d = 0
  
  If *p
    If *p\Thread
      Result = *p\CPU_Load
      PM\CPULoad = Result
    EndIf
  EndIf
  
  ProcedureReturn Result

EndProcedure
Procedure   KillProcess(PID)
  
  ; Beendet den Task sofort
  
  Protected Result = #False
  Protected pHnd = OpenProcess_(#PROCESS_TERMINATE, #False, PID) 
  
  If pHnd <> #Null 
    If TerminateProcess_(pHnd, 1) 
      Result = #True 
    EndIf 
    CloseHandle_(pHnd) 
  EndIf 
  
  ProcedureReturn Result 

EndProcedure
;
Procedure.f Prozent(aMin.f, aMax.f)
  
  ; Hilfsprozedure um Prozent zu ermitteln
  Protected c.f=aMin/aMax	
  c=c*100
  ProcedureReturn C
  
EndProcedure
Procedure   Center(Max, Value)
  ; Hilfsprozedur um den Beginn eines Rechtecks in einem
  ; Rechteck zu ermitteln ;)
  ProcedureReturn (Max/2)-(Value/2)
EndProcedure
Procedure.s GetSpecialFolder(CSIDL)
  
  ;###### Author : ts-soft
  ; Gibt Windowssystempfade zurueck. z.B.: #CSIDL_APPDATA
  
  Protected *itemid.ITEMIDLIST
  Protected location.s = Space(#MAX_PATH)
  
  If SHGetSpecialFolderLocation_ (0, CSIDL, @*itemid) = #NOERROR
    If SHGetPathFromIDList_(*itemid, @location)
      CoTaskMemFree_(*itemid)
      If Right(location, 1) <> "\" : location + "\" 
      EndIf
      ProcedureReturn location
    EndIf
  EndIf
  
EndProcedure
Procedure   MakeDir(dir.s, rel2program = #False)
  
  ;###### Author : ts-soft
  ; Stellt sicher das alle Directories vorhanden sind
  Protected.i Index = 2, count, i, length
  Protected.s actDir, dir2

  If dir = "" : ProcedureReturn #False : EndIf
  length = ExpandEnvironmentStrings_(dir, @dir2, 0)
  If length
    dir2 = Space(length)
    If ExpandEnvironmentStrings_(dir, @dir2, length)
      dir = dir2
    EndIf
  EndIf
  dir = ReplaceString(dir, "/", "\")
  If Right(dir, 1) <> "\" : dir + "\" : EndIf
  If FileSize(dir) = -2 : ProcedureReturn #True : EndIf
  If Left(dir, 1) = "\"
    dir = Right(dir, Len(dir) -1)
  EndIf
  If Not Right(StringField(dir, 1, "\"), 1) = ":"
    If rel2program
      dir = GetPathPart(ProgramFilename()) + dir
    Else
      dir = GetCurrentDirectory() + dir
    EndIf
    If FileSize(dir) = -2 : ProcedureReturn #True : EndIf
  EndIf
  actDir = StringField(dir, 1, "\") + "\"
  count = CountString(dir, "\")
  For i = Index To count
    actDir + StringField(dir, i, "\") + "\"
    If FileSize(actDir) = -2 : Continue : EndIf
    CreateDirectory(actDir)
  Next
  If FileSize(dir) = -2 : ProcedureReturn #True : EndIf
EndProcedure
Procedure.s ZahlToString(Wert)
  ; Wandelt eine mind. 4stellige Zahl in einen String
  ; Mit punkten um : aus 9123456 wird 9.123.456
  Protected.s R, T
  R.s = Str(Wert) : T.s = ""
  Repeat
    T = Right(R,3)+"." + T : R = Left(R,Len(R)-3)
  Until Len(R) <3
  If Len(R) > 0 : T = R+"."+T : EndIf
  ProcedureReturn Left(T,Len(T)-1)
  
EndProcedure
;
Procedure   PrefsRead()
  
  ; Liest die Programmeinstellungen
  Protected FileName.s = GetSpecialFolder(#CSIDL_APPDATA) + "PureBasic\PureMonitor\PureMonitor.prefs"
  Protected DeskW = GetSystemMetrics_(#SM_CXSCREEN), DeskH = GetSystemMetrics_(#SM_CYSCREEN)

  MakeDir(GetPathPart(FileName))
  
  OpenPreferences(FileName)
  
  With PP
    \WinSize\left   = ReadPreferenceInteger("WindowX", Center(DeskW, 300))
    \WinSize\top    = ReadPreferenceInteger("WindowY", Center(DeskH, 300))
    \WinSize\right  = ReadPreferenceInteger("WindowWidth", 300)
    \WinSize\bottom = ReadPreferenceInteger("WindowHeight", 300)
    \VAlert         = ReadPreferenceInteger("VisualAlert", 0)
    \AAlert         = ReadPreferenceInteger("AcousticAlert", 0)
    \TresholdCPU    = ReadPreferenceInteger("TresholdCPU", 100)
    \TresholdRAM    = ReadPreferenceInteger("TresholdRAM", 1000000)
    \SoundFile      = ReadPreferenceString("SoundFile", "BuiltIn")
    \LogEvery       = ReadPreferenceInteger("LogEvery_X_Minutes", 1)
    \LogFile        = ReadPreferenceInteger("LogFile", 0)
    \Volume         = ReadPreferenceInteger("SoundVolume", 10)
  EndWith  
  
  ClosePreferences()
  
EndProcedure
Procedure   PrefsWrite()
  ; Schreibt die Programmeinstellungen
  Protected FileName.s = GetSpecialFolder(#CSIDL_APPDATA) + "PureBasic\PureMonitor\PureMonitor.prefs"
  
  MakeDir(GetPathPart(FileName))
  
  CreatePreferences(FileName)
  
  PreferenceComment("---------------------------------------------")
  PreferenceComment("PureMonitor - Preferences File --------------")
  PreferenceComment("---------------------------------------------")
  PreferenceComment("")
  
  With PP
    
    PreferenceComment("WindowSize and Position ---------------------")
    PreferenceComment("---------------------------------------------")
    WritePreferenceInteger("WindowX",           WindowX(PM\Window))
    WritePreferenceInteger("WindowY",           WindowY(PM\Window))
    WritePreferenceInteger("WindowWidth",       WindowWidth(PM\Window))
    WritePreferenceInteger("WindowHeight",      WindowHeight(PM\Window))
    PreferenceComment("")
    PreferenceComment("Acoustic and Visual Alerts ------------------")
    PreferenceComment("---------------------------------------------")
    WritePreferenceInteger("TresholdCPU",       \TresholdCPU)
    WritePreferenceInteger("TresholdRAM",       \TresholdRam)
    WritePreferenceInteger("VisualAlert",       \VAlert)
    WritePreferenceInteger("AcousticAlert",     \AAlert)
    WritePreferenceString( "SoundFile",         \SoundFile)
    WritePreferenceInteger("SoundVolume",       \Volume)
    PreferenceComment("")
    PreferenceComment("Logfile -------------------------------------")
    PreferenceComment("---------------------------------------------")
    WritePreferenceInteger("LogEvery_X_Minutes",\LogEvery)
    WritePreferenceInteger("LogFile",           \LogFile)

  EndWith
    
  ClosePreferences()  
  
EndProcedure
;
Procedure   StartProgram()
  ; Der Programmstart (PureMonitor)
  PrefsRead()
  
  PM\PID        = GetProgramID()
  PM\CPU_LOGO   = CatchImage(#PB_Any, ?PM_CPU_LOGO)
  PM\RAM_LOGO   = CatchImage(#PB_Any, ?PM_RAM_LOGO)
  PM\PB_Logo    = CatchImage(#PB_Any, ?PM_PBLOGO)
  PM\Hnd_Logo   = CatchImage(#PB_Any, ?PM_HandleLogo)
  PM\CheckLogo  = CatchImage(#PB_Any, ?_001_checked)
  PM\UncheckLogo= CatchImage(#PB_Any, ?_001_unchecked)
  
  PM\Font       = LoadFont(#PB_Any, "Courier New", 10)
  PM\CPUName    = GetCPUName()
  
  
  If PP\SoundFile <> "BuiltIn"
    If FileSize(PP\SoundFile)>0
      PM\Sound = LoadSound(#PB_Any, PP\SoundFile)
    EndIf
  EndIf
  If Not PM\Sound
    PM\Sound = CatchSound(#PB_Any, ?PM_SOUND)
  EndIf  
  
  SoundVolume(PM\Sound, PP\Volume)
  
EndProcedure
;
Procedure   LogCreate()
  ; Logfile erstellen
  Protected FileName.s = GetSpecialFolder(#CSIDL_APPDATA) + "PureBasic\PureMonitor\PureMonitor_"+#Processor+".log"
  Protected File
  
  MakeDir(GetPathPart(FileName))
  
  If FileSize(FileName) > 0 : DeleteFile(FileName) : EndIf
  
  File = CreateFile(#PB_Any, FileName)
  
  If File
    
    WriteStringN(File, "PureMonitor - Logfile ("+#Processor+")")
    WriteStringN(File, "Exe : "+PM\Name)
    WriteStringN(File, "PID : "+Str(PM\PID))
    WriteStringN(File, "TRam: "+ZahlToString(MemoryStatus(#PB_System_TotalPhysical)/1024)+" KB")
    WriteStringN(File, LSet("",130,"-"))
    CloseFile(File)
    
  EndIf  
  
EndProcedure
Procedure   LogWrite(Extra.s = "", Mode = 0)
  ; in ein vorhandenes Logfile eintragen
  Protected FileName.s = GetSpecialFolder(#CSIDL_APPDATA) + "PureBasic\PureMonitor\PureMonitor_"+#Processor+".log"
  Protected File, S.s = FormatDate("%hh:%ii:%ss",Date())+" >>> "
  
  S + "CPU : "+StrD(PM\CPULoad,1)+" ; "
  S + "MCPU: "+StrD(PM\MaxCPULoad,1)+" ; "
  S + "RAM : "+ZahlToString(PM\Ram)+" KB ; "
  S + "MRAM: "+ZahlToString(PM\MaxRam)+" KB ; " 
  S + "PH: "+Str(PM\ProcHandles)+" ; "
  S + "GH: "+Str(PM\GDIHandles)+" ; "
  If OSVersion() >= #PB_OS_Windows_7
    S + "GP: "+Str(PM\GDIPeak)+" ; "
  EndIf
  S + "UH: "+Str(PM\UserHandles)+" ; "
  If OSVersion() >= #PB_OS_Windows_7
    S + "UP: "+Str(PM\UserPeak)+" ; "
  EndIf
  
  If Right(S,3) = " ; " : S = Left(S, Len(S)-3) : EndIf
  
  File = OpenFile(#PB_Any, FileName, #PB_File_Append)
  
  If File
    
    If Mode = 0
      WriteStringN(File, S)
      If Extra <> ""
        WriteStringN(File, FormatDate("%hh:%ii:%ss",Date())+" >>> "+Extra)
      EndIf
    Else
      WriteStringN(File, FormatDate("%hh:%ii:%ss",Date())+" >>> "+Extra)
    EndIf
    
    CloseFile(File)
  EndIf
  
EndProcedure
;
Procedure   MakeBox(Image_ID, Size = 32)
  ; Zeichnet box und ein Image (Hintergrund)
  DrawingMode(#PB_2DDrawing_Default)
  
  Box(0, 0, OutputWidth(), OutputHeight(), PM\WColor)
  
  DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Gradient)
  BackColor(RGB(237,237,237)) : FrontColor(RGB(200,200,200))
  LinearGradient(0,0,0, OutputHeight())
  RoundBox(10, 10, OutputWidth()-20, OutputHeight()-20, 3, 3, 0)
    
  DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Outlined)
  RoundBox(10, 10, OutputWidth()-20, OutputHeight()-20, 3, 3, RGB(150,150,150))
  
  DrawingMode(#PB_2DDrawing_Default)
  
  If Image_ID
    If Size = -1
      DrawAlphaImage(Image_ID, 0, 0, 255)
    Else
      DrawImage(Image_ID, 0, 0, Size, Size)
    EndIf
  EndIf  
  
  DrawingFont(FontID(PM\Font))
  
EndProcedure
;
Procedure   TitleGadget()
  
  ; TaskName mit PID und Prozessor 
  Protected Name.s = PM\Name
  
  If IsGadget(PM\G_Title)
    If StartDrawing(CanvasOutput(PM\G_Title))
      
      MakeBox(PM\Icon)
      
      While TextWidth(Name) > OutputWidth()-60
        Name = Left(Name, Len(Name) - 1)
      Wend      
      
      DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_Gradient)
      BackColor(0) : FrontColor(RGB(228,228,228))
      LinearGradient(40,0,OutputWidth()-20,0)
      GradientColor(0.7, 0)      
      DrawText(40,10+Center(32-10,TextHeight("W")),Name,0)
      DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Transparent)
      DrawText(40,32,"PID: "+Str(PM\PID)+" ("+#Processor+")", 0)      
      
      StopDrawing()
    EndIf
  EndIf
    
EndProcedure
Procedure   CPU_Gadget()
  ; Name der CPU und die Auslastung
  Protected Name.s = PM\CPUName, WW, Meter.f, MMeter.f, CL.d = PM\CPULoad
  Static CM.d
  
  If IsGadget(PM\G_CPU)
    If StartDrawing(CanvasOutput(PM\G_CPU))
      
      WW = OutputWidth()-80
      
      Meter = (WW/100) * CL
      
      If CL>=CM
        CM = CL
      EndIf
      
      MMeter = (WW/100) * CM
      
      MakeBox(ImageID(PM\CPU_LOGO))  
      While TextWidth(Name) > OutputWidth()-60
        Name = Left(Name, Len(Name) - 1)
      Wend
      
      
      DrawingMode(#PB_2DDrawing_Transparent|#PB_2DDrawing_Gradient)
      BackColor(0) : FrontColor(RGB(228,228,228))
      LinearGradient(40,0,OutputWidth()-40,0)
      GradientColor(0.7, 0)      
      DrawText(40,10+Center(32-10,TextHeight("W")),Name,0)
      
      DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Gradient)
      BackColor(RGB(0,255,0)) : FrontColor(RGB(255,0,0))
      
      LinearGradient(40,0,ww,0)
      GradientColor(0.45, RGB(255,255,0))
      GradientColor(0.7, RGB(255,255,0))
      Box(40, 35, Meter, 10, 0)
      
      DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Outlined)
      Line(40+MMeter, 35, 1, 10, #Black)
      Box(39, 35, WW+2, 10,0)
      
      DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Transparent)
      DrawText(40,50,StrD(PM\CPULoad,1)+"%",0)
      DrawText((40+ww)-TextWidth(StrD(PM\MaxCPULoad,1)+"%"),50,StrD(PM\MaxCPULoad,1)+"%",#Red)      
      StopDrawing()
      
    EndIf
  EndIf
  
EndProcedure
Procedure   Ram_Gadget()
  ; Speicherauslastung
  If IsGadget(PM\G_RAM)
    If StartDrawing(CanvasOutput(PM\G_RAM))
      
      MakeBox(ImageID(PM\RAM_LOGO))
      
      DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Transparent)
      DrawText(40,10+Center(32-10,TextHeight("W")),"Total RAM : "+ZahlToString(MemoryStatus(#PB_System_TotalPhysical)/1024)+" KB",0)
      DrawText(40,35,"Use : "+ZahlToString(PM\Ram)+" KB",0)
      DrawText(40,50,"Max : "+ZahlToString(PM\MaxRam)+" KB",RGB(200,0,0))
      StopDrawing()
    EndIf
  EndIf
  
EndProcedure
Procedure   Handle_Gadget()
  ; Handles
  Protected WW, TU, TG, MinW
  
  If IsGadget(PM\G_Handles)
    If StartDrawing(CanvasOutput(PM\G_Handles))
      
      WW = OutputWidth()-60
      
      MakeBox(ImageID(PM\Hnd_Logo))
      
      DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Transparent)
      DrawText(40,10+Center(32-10,TextHeight("W")),"Handles : "+ZahlToString(PM\ProcHandles),0)
      DrawText(30,35,"GuiH  : "+ZahlToString(PM\GDIHandles),0)
      DrawText(30,50,"UserH : "+ZahlToString(PM\UserHandles),0)
      
      If OSVersion() >= #PB_OS_Windows_7
        TG = TextWidth("GuiP  : "+ZahlToString(PM\GDIPeak))
        TU = TextWidth("UserP : "+ZahlToString(PM\UserPeak))
        If TG>=TU
          MinW = TG
        Else
          MinW = TU
        EndIf
        
        DrawText((30+ww)-MinW,35,"GuiP  : "+ZahlToString(PM\GDIPeak),0)     
        DrawText((30+ww)-MinW,50,"UserP : "+ZahlToString(PM\UserPeak),0) 
      EndIf
      
      StopDrawing()
    EndIf
  EndIf
  
EndProcedure
;
Procedure   Main()
  ; Das eigentliche Programm
  Protected Event, Quit, Width, mx, my, y, x
  Protected *p.task_monitoring_struct
  Protected GLogFile, GLogT, GLogT2, GLogEvery, FirstLog = 0, EveryState, oldlogtime, GKillProcess
  
  StartProgram()
  
  If PM\PID : *p = TaskMonitorOn(PM\PID)  : EndIf
  If Not *p : ProcedureReturn #False      : EndIf
  
  Delay(100)
  
  LogCreate()
  
  PM\Window =   OpenWindow(#PB_Any, PP\WinSize\left, PP\WinSize\top, PP\WinSize\right, PP\WinSize\bottom, "PureMonitor", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_SizeGadget)
  
  WindowBounds(PM\Window, 300, #PB_Ignore, 300, 400)
  
  If IsWindow(PM\Window)
    PM\WColor = GetWindowColor(PM\Window)
    If PM\WColor = -1
      PM\WColor = GetSysColor_(#COLOR_3DFACE)
    EndIf
  EndIf  
  If Not PM\Icon : PM\Icon = ImageID(PM\PB_Logo) : EndIf
  
  y = 5
  
  PM\G_Title    = CanvasGadget(#PB_Any, 5, y, WindowWidth(PM\Window)-10, 60) : y + 65
  PM\G_CPU      = CanvasGadget(#PB_Any, 5, y, WindowWidth(PM\Window)-10, 80) : y + 85
  PM\G_RAM      = CanvasGadget(#PB_Any, 5, y, WindowWidth(PM\Window)-10, 80) : y + 85
  PM\G_Handles  = CanvasGadget(#PB_Any, 5, y, WindowWidth(PM\Window)-10, 80) : y + 80
  
  SetGadgetFont(#PB_Default, FontID(PM\Font))
  
  
  
  x = 20
  GKillProcess = ButtonGadget(#PB_Any, x, y, 300 - (x*2), 20, "Kill Process (PID:"+Str(PM\PID)+")")
  y + 25
  
  GLogFile= CheckBoxGadget(#PB_Any, x, y, 130, 20, "LogFile every") : x + 130
  GLogEvery=SpinGadget(#PB_Any,x,y,45,20,1,100,#PB_Spin_Numeric) : x + 55
  GLogT2  = TextGadget(#PB_Any,x,y,45,20,"min.",#SS_CENTERIMAGE): y + 25
  
  TitleGadget() : CPU_Gadget() : Ram_Gadget() : Handle_Gadget()
  
  SetGadgetState(GLogEvery, PP\LogEvery)
  SetGadgetState(GLogFile, PP\LogFile)
  
  If PP\LogFile = 1
    FirstLog = 1
    LogCreate()
    LogWrite("User start logging (LogTimer = "+Str(PP\LogEvery)+" min.)",1)
    LogWrite()
    AddWindowTimer(PM\Window, #Log_Timer, (PP\LogEvery * 1000 * 60))
  EndIf
  
  AddWindowTimer(PM\Window, #CPU_Timer_Event, #CPU_Timer)
  
  StickyWindow(PM\Window, #True)
  Repeat
    
    Event = WaitWindowEvent(25)
    
    Select Event
      Case #PB_Event_CloseWindow
        If PP\LogFile = 1
          LogWrite("User terminate PureMonitor !")
        EndIf
        Quit = 1
        
      Case #PB_Event_SizeWindow
        Width = WindowWidth(PM\Window)
        If Width <= 300 : Width = 300 : EndIf
        ResizeGadget(PM\G_Title, #PB_Ignore, #PB_Ignore, Width-10, 60)
        ResizeGadget(PM\G_CPU  , #PB_Ignore, #PB_Ignore, Width-10, 80)
        ResizeGadget(PM\G_RAM  , #PB_Ignore, #PB_Ignore, Width-10, 80)
        ResizeGadget(PM\G_Handles, #PB_Ignore, #PB_Ignore, Width-10, 80)

        TitleGadget() : CPU_Gadget() : Ram_Gadget() : Handle_Gadget()
      Case #PB_Event_Timer
        Select EventTimer()
          Case #CPU_Timer_Event
            If *p\Halt = 0
              PM\CPULoad = *p\CPU_Load
              PM\Ram     = *p\MemUsage / 1024
              If PM\CPULoad >= PM\MaxCPULoad : PM\MaxCPULoad = PM\CPULoad : EndIf 
              If PM\Ram >= PM\MaxRam : PM\MaxRam = PM\Ram : EndIf
              GetHandleCounters()
              CPU_Gadget() : Ram_Gadget() : Handle_Gadget()
            Else
              If PP\LogFile = 1
                LogWrite()
                LogWrite("Process PID:"+Str(PM\PID)+" ends",1)
                RemoveWindowTimer(PM\Window, #Log_Timer)
                KillProcess(PM\PID)
              EndIf   
              Quit = 1  
            EndIf
          
          Case #Log_Timer
            LogWrite()
            
        EndSelect
      Case #PB_Event_Gadget
        Select EventGadget()
          Case GLogFile
            Select GetGadgetState(GLogFile)
              Case 0
                LogWrite()
                LogWrite("User stopped logging",1)
                RemoveWindowTimer(PM\Window, #Log_Timer)
                PP\LogFile = 0
              Case 1
                If FirstLog = 0
                  FirstLog = 1
                  LogCreate()
                EndIf
                LogWrite("User start logging (LogTimer = "+Str(PP\LogEvery)+" min.)",1)
                LogWrite()
                AddWindowTimer(PM\Window, #Log_Timer, (PP\LogEvery * 1000 * 60))
                PP\LogFile = 1
            EndSelect
          Case GLogEvery
            EveryState = GetGadgetState(GLogEvery)
            oldlogtime = PP\LogEvery
            If EveryState > 0 And EveryState < 101
              If EveryState <> oldlogtime
                PP\LogEvery = EveryState
                
                If PP\LogFile = 1
                  RemoveWindowTimer(PM\Window, #Log_Timer)
                  LogWrite()
                  LogWrite("User changed Logtimer to "+Str(PP\LogEvery)+" min.")
                  AddWindowTimer(PM\Window, #Log_Timer, PP\LogEvery)
                EndIf
              EndIf
              
            EndIf
            
          Case GKillProcess
            If PP\LogFile = 1
              LogWrite()
              LogWrite("User kill process PID:"+Str(PM\PID),1)
              RemoveWindowTimer(PM\Window, #Log_Timer)
              KillProcess(PM\PID)
            Else
              KillProcess(PM\PID)              
            EndIf   

        EndSelect
        
            
    EndSelect
    
  Until Quit > 0
  
  DestroyIcon_(PM\Icon)
  
  PrefsWrite()
  
  TaskMonitorOff(*p)
  
  If PP\LogFile = 1
    LogWrite("End of Log",1)
    RunProgram(GetSpecialFolder(#CSIDL_APPDATA) + "PureBasic\PureMonitor\PureMonitor_"+#Processor+".log")
  EndIf
  
  
  
EndProcedure
;
DataSection
  
  _001_unchecked: ;{
  Data.q $1818000100010000,$0988002000010000,$0028000000160000,$0030000000180000,$0000002000010000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$B1B1000000000000,$8B8BFF989898FFB1
  Data.q $8B8BFF8B8B8BFF8B,$8B8BFF8B8B8BFF8B,$8B8BFF8B8B8BFF8B,$9898FF8B8B8BFF8B,$0000FFB1B1B1FF98
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $AEAEFFB2B2B20000,$F3F3FFD9D9D9FFAE,$F3F3FFF3F3F3FFF3,$F3F3FFF3F3F3FFF3,$F3F3FFF3F3F3FFF3
  Data.q $D9D9FFF3F3F3FFF3,$B2B2FFAEAEAEFFD9,$000000000000FFB2,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$DADAFF9898980000,$ECECFFECECECFFDA,$ECECFFECECECFFEC
  Data.q $ECECFFECECECFFEC,$ECECFFECECECFFEC,$ECECFFECECECFFEC,$9898FFDADADAFFEC,$000000000000FF98
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$F3F3FF8B8B8B0000
  Data.q $ECECFFECECECFFF3,$ECECFFECECECFFEC,$ECECFFECECECFFEC,$ECECFFECECECFFEC,$ECECFFECECECFFEC
  Data.q $8B8BFFF3F3F3FFEC,$000000000000FF8B,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$F3F3FF8B8B8B0000,$ECECFFECECECFFF3,$ECECFFECECECFFEC,$ECECFFECECECFFEC
  Data.q $ECECFFECECECFFEC,$ECECFFECECECFFEC,$8B8BFFF3F3F3FFEC,$000000000000FF8B,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$F3F3FF8B8B8B0000,$ECECFFECECECFFF3
  Data.q $ECECFFECECECFFEC,$ECECFFECECECFFEC,$ECECFFECECECFFEC,$ECECFFECECECFFEC,$8B8BFFF3F3F3FFEC
  Data.q $000000000000FF8B,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $F3F3FF8B8B8B0000,$ECECFFECECECFFF3,$ECECFFECECECFFEC,$ECECFFECECECFFEC,$ECECFFECECECFFEC
  Data.q $EDEDFFECECECFFEC,$8B8BFFF3F3F3FFED,$000000000000FF8B,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$F6F6FF8B8B8B0000,$F6F6FFF6F6F6FFF6,$F6F6FFF6F6F6FFF6
  Data.q $F6F6FFF6F6F6FFF6,$F6F6FFF6F6F6FFF6,$F6F6FFF6F6F6FFF6,$8B8BFFF6F6F6FFF6,$000000000000FF8B
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$F6F6FF8B8B8B0000
  Data.q $F6F6FFF6F6F6FFF6,$F6F6FFF6F6F6FFF6,$F6F6FFF6F6F6FFF6,$F6F6FFF6F6F6FFF6,$F6F6FFF6F6F6FFF6
  Data.q $8B8BFFF6F6F6FFF6,$000000000000FF8B,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$FAFAFF8B8B8B0000,$FAFAFFFAFAFAFFFA,$FAFAFFFAFAFAFFFA,$FAFAFFFAFAFAFFFA
  Data.q $FAFAFFFAFAFAFFFA,$FAFAFFFAFAFAFFFA,$8B8BFFFAFAFAFFFA,$000000000000FF8B,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$FAFAFF8D8D8D0000,$FAFAFFFAFAFAFFFA
  Data.q $FAFAFFFAFAFAFFFA,$FAFAFFFAFAFAFFFA,$FAFAFFFAFAFAFFFA,$FAFAFFFAFAFAFFFA,$8D8DFFFAFAFAFFFA
  Data.q $000000000000FF8D,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $E2E2FF9C9C9C0000,$FFFFFFFFFFFFFFE2,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF
  Data.q $FFFFFFFFFFFFFFFF,$9292FFE2E2E2FFFF,$000000000000FF92,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$B3B3FFBABABA0000,$FFFFFFE2E2E2FFB3,$FFFFFFFFFFFFFFFF
  Data.q $FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$E2E2FFFFFFFFFFFF,$BABAFFB3B3B3FFE2,$000000000000FFBA
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$BBBB000000000000
  Data.q $9494FFA1A1A1FFBB,$9494FF949494FF94,$9494FF949494FF94,$9494FF949494FF94,$A1A1FF949494FF94
  Data.q $0000FFBBBBBBFFA1,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $FFFF000000000000,$FFFF41FFFFFF41FF,$00FC41FFFFFF41FF,$00F8411F00F8413F,$00F8411F00F8411F
  Data.q $00F8411F00F8411F,$00F8411F00F8411F,$00F8411F00F8411F,$00F8411F00F8411F,$FFFF413F00FC411F
  Data.q $FFFF41FFFFFF41FF,$FFFF41FFFFFF41FF,$000041FFFFFF41FF
  ;}
  _001_checked: ;{
  Data.q $1818000100010000,$0988002000010000,$0028000000160000,$0030000000180000,$0000002000010000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$B1B1000000000000,$8B8BFF989898FFB1
  Data.q $8B8BFF8B8B8BFF8B,$8B8BFF8B8B8BFF8B,$8B8BFF8B8B8BFF8B,$9898FF8B8B8BFF8B,$0000FFB1B1B1FF98
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $AEAEFFB2B2B20000,$F3F3FFD9D9D9FFAE,$F2F2FFF2F2F2FFF3,$F2F2FFF2F2F2FFF2,$F2F2FFF2F2F2FFF2
  Data.q $D9D9FFF3F3F3FFF2,$B2B2FFAEAEAEFFD9,$000000000000FFB2,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$DADAFF9898980000,$EFEFFFF1F1F1FFDA,$EEEEFFEEEEEEFFEF
  Data.q $EEEEFFEEEEEEFFEE,$EEEEFFEEEEEEFFEE,$F1F1FFEFEFEFFFEE,$9898FFDADADAFFF1,$000000000000FF98
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$F5F5FF8B8B8B0000
  Data.q $EDEDFFEFEFEFFFF5,$EDEDFFEDEDEDFFED,$F4F4FFF1F1F1FFED,$EDEDFFF0F0F0FFF4,$EFEFFFEDEDEDFFED
  Data.q $8B8BFFF5F5F5FFEF,$000000000000FF8B,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$F4F4FF8B8B8B0000,$ECECFFEEEEEEFFF4,$F0F0FFECECECFFEC,$3939FF848484FFF0
  Data.q $EDEDFFA7A7A7FF39,$EEEEFFECECECFFED,$8B8BFFF4F4F4FFEE,$000000000000FF8B,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$F3F3FF8B8B8B0000,$ECECFFEDEDEDFFF3
  Data.q $9898FFEFEFEFFFEC,$3535FF353535FF98,$D6D6FF393939FF35,$EDEDFFECECECFFD6,$8B8BFFF3F3F3FFED
  Data.q $000000000000FF8B,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $F3F3FF8B8B8B0000,$EEEEFFEDEDEDFFF3,$3535FFB3B3B3FFEE,$3535FF353535FF35,$6161FF353535FF35
  Data.q $EDEDFFEFEFEFFF61,$8B8BFFF3F3F3FFED,$000000000000FF8B,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$F9F9FF8B8B8B0000,$CECEFFF6F6F6FFF9,$3535FF3C3C3CFFCE
  Data.q $A8A8FF555555FF35,$3535FF353535FFA8,$F6F6FFA7A7A7FF35,$8B8BFFF9F9F9FFF6,$000000000000FF8B
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$FBFBFF8B8B8B0000
  Data.q $4E4EFFF9F9F9FFFB,$4141FF353535FF4E,$F9F9FFDBDBDBFF41,$3535FF717171FFF9,$E6E6FF3E3E3EFF35
  Data.q $8B8BFFFBFBFBFFE6,$000000000000FF8B,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$FDFDFF8B8B8B0000,$7272FFFDFDFDFFFD,$C2C2FF3C3C3CFF72,$FDFDFFFDFDFDFFC2
  Data.q $4141FFE8E8E8FFFD,$7070FF353535FF41,$8B8BFFFDFDFDFF70,$000000000000FF8B,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$FFFFFF8D8D8D0000,$FFFFFFFFFFFFFFFF
  Data.q $FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$AEAEFFFFFFFFFFFF,$3535FF353535FFAE,$8D8DFFB5B5B5FF35
  Data.q $000000000000FF8D,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $E2E2FF9C9C9C0000,$FFFFFFFFFFFFFFE2,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF
  Data.q $3535FF656565FFFF,$9292FF3F3F3FFF35,$000000000000FF92,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$B3B3FFBABABA0000,$FFFFFFE2E2E2FFB3,$FFFFFFFFFFFFFFFF
  Data.q $FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$3636FFE2E2E2FFFF,$6060FF353535FF36,$000000000000FF60
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$BBBB000000000000
  Data.q $9494FFA1A1A1FFBB,$9494FF949494FF94,$9494FF949494FF94,$9494FF949494FF94,$6C6CFF949494FF94
  Data.q $3535FF353535FF6C,$000000000000FF35,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$3535FF5555550000,$0000FF4C4C4CFF35,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$5050000000000000
  Data.q $0000FF717171FF50,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $FFFF000000000000,$FFFF41FFFFFF41FF,$00FC41FFFFFF41FF,$00F8411F00F8413F,$00F8411F00F8411F
  Data.q $00F8411F00F8411F,$00F8411F00F8411F,$00F8411F00F8411F,$00F8411F00F8411F,$FFFF411F00FC411F
  Data.q $FFFF41CFFFFF418F,$FFFF41FFFFFF41FF,$000041FFFFFF41FF
  ;}
  PM_RAM_LOGO: ;{
  Data.q $2020000100010000,$10A8002000010000,$0028000000160000,$0040000000200000,$0000002000010000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000100,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$5D5F000000000000,$000020000000725B,$0000000000000100
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000725A5D5F0000,$787B000000001000,$00002E000000FF75
  Data.q $0000080000003100,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$6366000000000000,$00000E0000006E61,$0000FF7476790000,$8D90180000003A00
  Data.q $000000000000FF89,$00003A0000001C00,$0000040000001600,$0000280000001700,$0000070000002500
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$000069686B6D0000,$7477000000000600,$00003B000000FF71,$0000FF878A8D1500
  Data.q $A1A4370000000900,$242600000000FF9D,$0C0C3D191A1B1124,$00003E0000003F0C,$0000320000003800
  Data.q $6D72260000002D00,$000002313334C16B,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $6365020000000000,$0000020000007260,$0000FF6F71740000,$888B0B0000003800,$00000E000000FF84
  Data.q $0000FF9A9EA23A00,$AAAE142D2F300000,$3235CA292A2CFFA6,$1C1CFF37383CFF31,$0000750F0F0FFF1C
  Data.q $0000340000003A00,$6D72290000002E00,$222338202222F36B,$0000000000000621,$0000000000000000
  Data.q $00006E6467690000,$6F72020000000200,$00002F000000FF6C,$0000FF8285880200,$9C9F3A0000001500
  Data.q $2C2E00000000FF98,$2C2EFFA4A9AD232A,$B1B5F8494B4EF42B,$3336D2424347FFAD,$1D1DFF35363AFF32
  Data.q $1919F71F1F1FFF1D,$00003B020202C519,$6E732A0000002F00,$1E1F35171818F36C,$00000B161718341D
  Data.q $0000000000000000,$0000FF6A6C6F0100,$8386020000002C00,$000029000000FF80,$0000FF969A9E3100
  Data.q $A6AA1B1718180000,$4A4DC2262729FFA2,$4D52FFACAFB4FF49,$BCC1E96D6F73FF4C,$3437F7909397FFB8
  Data.q $1D1DFF38393DFF33,$1E1EFF1D1D1DFF1D,$1515F31E1E1EFF1E,$6E732B0000005D14,$0F0F20000000F36C
  Data.q $11112A191A1A260E,$0000010000000F10,$0000FF7D80830000,$979A2E0000002800,$141500000000FF93
  Data.q $2D2EFFA1A5A93813,$AEB2F6484A4DEB2C,$6F74E13F4144FFAA,$9297FFB7BBBFFF6D,$E9ECFD8E9196FF8F
  Data.q $5E60FDA3A6AAFFE7,$5152FF545354FF5E,$1E1EFF303031FF52,$1C1CFF1D1D1DFF1E,$6D72A6191919FA1C
  Data.q $00007E5C5E62F36B,$13141B0506061D00,$00000F0A0A0A1D13,$0000FF9194980000,$A2A62F0D0E0E0000
  Data.q $4A4DBB242527FF9E,$494DFFA8ACB0FE48,$BABFF06A6C70FF47,$9297F78E9195FFB6,$A6AAFFE7E9ECFF8F
  Data.q $9EA2DE5C5C5DFFA3,$898CFF939699FF9C,$5253FF4B4A4BFF86,$4242FF555556FF52,$1C1CFF222222FF42
  Data.q $2526FF1B1B1BFF1C,$00006F434448F925,$0202190000001E00,$9EA2120506061502,$3032FF9CA0A4049A
  Data.q $AAAEE74C4D51C92F,$6F72E93F4043FFA6,$9296FFB4B8BDFF6C,$E9ECFD8E9196FF8F,$7F82FEA2A6AAFFE7
  Data.q $8486FF8E9093FF7D,$4242FF6C6D6FFF82,$3C3CFF3F3F3FFF42,$3636FF393939FF3C,$4D4DFF383838FF36
  Data.q $3333FF535354FF4D,$1B1BFF1C1C1CFF33,$1717F91B1B1AFF1B,$0000190000007C17,$4E51010000000800
  Data.q $4B4EFFA4A8ACFB4C,$B7BCE4717377FF49,$9195F0919498FFB3,$A6AAFFE7E9ECFF8E,$8486E3575859FFA2
  Data.q $5252FF747677FF82,$4A4AFF4E4E4EFF52,$4343FF464646FF4A,$3C3CFF3F3F3FFF43,$3737FF393939FF3C
  Data.q $3333FF353535FF37,$5454FF3C3C3CFF33,$2323FF49494AFF54,$1A1AFF1C1C1CFF23,$000001000000FA1A
  Data.q $3334000000000000,$9498FFB1B5BAFF31,$E9ECFA8E9296FF90,$797BFDA2A6AAFFE7,$8D8FFF8B8D90FF77
  Data.q $5959FF5D5D5DFF8B,$5252FF565656FF59,$4B4BFF4E4E4EFF52,$5152FF474747FF4B,$4848FF4B4C4CFF51
  Data.q $3737FF474748FF47,$3333FF353535FF37,$3333FF333333FF33,$5556FF424243FF33,$1A1AFF3B3B3BFF55
  Data.q $000000000000F81A,$3334000000000000,$A6AAFFE7E9ECFF31,$8385FF76787AFFA3,$6566FF797A7BFF82
  Data.q $6060FF636363FF65,$5A5AFF5D5D5DFF60,$5353FF575757FF5A,$4C4CFF4F4F4FFF53,$5152FF555556FF4C
  Data.q $4D4DFF4E4F4FFF51,$4848FF4A4A4BFF4C,$3434FF363636FF47,$3333FF333333FF34,$3535FF333333FF33
  Data.q $2A2AFF474747FF35,$000000000000CD2A,$6364000000000000,$6868FF5F5F5FFF62,$6868FF686868FF68
  Data.q $6666FF686868FF68,$6C6CFF646464FF66,$6364FF676768FF6B,$5454FF616262FF63,$4D4DFF505050FF54
  Data.q $5353FF494949FF4D,$4D4EFF4F5050FF52,$3939FF49494AFF4D,$3434FF363636FF39,$3333FF333333FF34
  Data.q $3B3BFD373737FF33,$3939E63F3F3FFE3B,$0000000000003939,$8D8D000000000000,$5B5BEA6565646C8D
  Data.q $6565FF5F5F5FFF5B,$6666FF686868FF65,$6D6DFF6E6E6FFF66,$6868FF696A6AFF6C,$6262FF646565FF67
  Data.q $4D4DFF515151FF61,$4646FF4A4A4AFF4D,$3F3FFF434343FF46,$3939FF3C3C3CFF3F,$3C3CFE3A3A3AFF39
  Data.q $4141D73D3D3DF93C,$42426A4242428741,$0000000000003C42,$0000000000000000,$0000000000000000
  Data.q $B8B8000000000000,$5D5DBF71717130B8,$6262FF5D5D5DF75D,$6D6EFF656565FF62,$6869FF696A6AFF6D
  Data.q $5656FF646465FF68,$4E4EFF525252FF56,$4747FF4B4B4BFF4E,$4242FF434343FF47,$4242BB414141ED42
  Data.q $4444334444446242,$0000000000001B44,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$5F5F7F8383830000,$5E5EFF5B5B5BF35F
  Data.q $5D5DFF606060FF5E,$5656FF5A5A5AFF5D,$4C4CFD515151FF56,$4545A8484848E44C,$4444334444444C45
  Data.q $0000000000001B44,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $65655A9898980000,$5B5BF35B5B5BD665,$494995545454DC5B,$00001B4444445E49,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$FFFF000000000000
  Data.q $FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$F9FFFF1FFFFFFF7F,$40FE3F40C8FFFF0F
  Data.q $1080070002E20F40,$0084000080000300,$0000000000A00000,$0000030000000000,$0000070000000700
  Data.q $00C01F0000000700,$03FEFF1F00F8FF01,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF
  Data.q $0000FFFFFFFFFFFF
  ;}
  PM_CPU_LOGO: ;{
  Data.q $2020000100010000,$10A8002000010000,$0028000000160000,$0040000000200000,$0000002000010000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$664A0266664A0000,$67490567674A0467
  Data.q $6749056767490567,$6547056565470567,$664B056564490565,$684E0568684E0566,$674D0567674D0568
  Data.q $6B4D0568684D0567,$6A4C056B6B4C056B,$684A0568684B056A,$6B4B066A6A4A0668,$6D4C066D6D4C066B
  Data.q $6A4C066C6C4B066D,$6B4D066C6C4D066A,$0000016A6A4C046C,$644A000000000000,$79441465654A0364
  Data.q $7944558079444E80,$7A43578179445680,$7640517D77415580,$7C42567C773F527B,$7B435B837C435B83
  Data.q $7C445B827B445B82,$7A425C837C435C82,$783F577D7840577E,$7E4260837C42597E,$7E4360867F436185
  Data.q $7F4361867F446086,$7B4160857E436186,$7C3E5C807B3F5C81,$6B47146B6B495782,$644A00000000036B
  Data.q $85452D6464490764,$803BC8A2833EB4A2,$8A41D2A9873ECBA0,$863FC6A48740CBA7,$8A3FC8A0843DC5A2
  Data.q $8B40D1A9893FD2AB,$843CC9A3883ECDA7,$8A3FCC9F833BCAA0,$843BC7A0873DC6A2,$883CCFA3853BC79E
  Data.q $8A3CD3A88A3CD2A7,$863ACEA58A3CD3A8,$883AC99F8639CBA1,$8134C59B8337C79F,$6B436277762EBF99
  Data.q $664D01686847176B,$50387A6464550566,$4D32F4635136E65E,$4C2FF65E4C30F65F,$482CF55C4C2FF65D
  Data.q $4327F5554529F558,$4025F7534025F856,$3C22F14C3E23F350,$4326F24A3B21F14A,$4428F3534427F251
  Data.q $462AF5554428F454,$4F30F95F4D2EF657,$5233F8635233FA62,$5839F8655335F863,$5A3CF8695739F86A
  Data.q $6E3C886D6D3AF86C,$705F036767452C6E,$4040BA75756F0270,$3A3AFF3E3E3EFF40,$3535FF373737FF3A
  Data.q $3030FF323232FF35,$2B2BFF2E2E2EFF30,$2828FF2A2A2AFF2B,$2727FF272727FF28,$2727FF272727FF27
  Data.q $2929FF272727FF27,$2D2DFF2B2B2BFF29,$3131FF2F2F2FFF2D,$3737FF343434FF31,$3C3CFF393939FF36
  Data.q $4949FF3F3F3FFF3C,$6347EA5A5A57FF49,$0000026565443C63,$6565BA6B6B6A0000,$6363FF646565FF65
  Data.q $6363FF636363FF63,$6161FF626262FF63,$6161FF616161FF61,$6060FF606060FF61,$6060FF5F5F5FFF5F
  Data.q $5F5FFF5F5F5FFF5F,$5F5FFF5E5F5FFF5F,$5F5FFF5F5F5FFF5F,$5F5FFF5F5F5FFF5F,$6060FF5F5F5FFF5F
  Data.q $6061FF606060FF60,$6464FF606061FF61,$5852FF6B6B6BFF64,$0000015C5C4B9F58,$5959795151510000
  Data.q $5858FF595959FF59,$5858FF585858FF58,$5758FF585858FF58,$5757FF585858FF57,$5757FF575858FF57
  Data.q $5757FF575757FF57,$5757FF575757FF57,$5757FF575757FF57,$5757FF575757FF57,$5757FF575757FF57
  Data.q $5858FF585858FF57,$5858FF585858FF58,$5959FF595959FF58,$5F5FFF5F5F5FFF59,$000000000000AA5F
  Data.q $56562F4A4A490000,$5858FF585858FF56,$5858FF575757FF58,$5E5EFF595959FF58,$5657FF696969FF5E
  Data.q $5656FF585858FF56,$5857FF575757FF56,$5757FF565656FF58,$5656FF585959FF57,$5656FF595959FF56
  Data.q $5757FF585858FF56,$5959FF585858FF57,$5757FF565657FF59,$5858FF585858FF57,$5150FF585858FF58
  Data.q $0000000000007D51,$5150014646440000,$5757FF575757E251,$7676FF575757FF57,$7272FF656665FF76
  Data.q $6F6FFF626262FF72,$5858FF737373FF6F,$6B6BFF646464FF58,$7777FF5B5B5BFF6B,$5D5DFF656565FF77
  Data.q $5B5BFF7F7F7FFF5D,$6969FF7F7F7FFF5B,$7878FF696969FF69,$5757FF5E5E5EFF78,$5757FF575757FF57
  Data.q $4C4CFF555555FF57,$000000000000334C,$4B4A000000000000,$5656FF565657994B,$6E6EFF565656FF56
  Data.q $7373FF656565FF6D,$7272FF5E5E5FFF73,$5A5AFF6F7070FF72,$7373FF757575FF5A,$7878FF646464FF73
  Data.q $5B5BFF616161FF77,$6868FF7C7C7CFF5B,$6868FF717171FF68,$6D6DFF5D5D5DFF68,$5D5DFF636363FF6D
  Data.q $5656FF565656FF5D,$4949E6505050FF56,$0000000000000249,$4846000000000000,$5555FF5454544F48
  Data.q $5555FF555555FF55,$5656FF575757FF55,$5555FF555555FF55,$6767FF575757FF55,$5555FF595959FF67
  Data.q $5555FF565656FF55,$5454FF575757FF55,$5454FF575757FF54,$5656FF565656FF54,$5858FF555555FF56
  Data.q $5555FF565656FF58,$5555FF555555FF55,$00009D4A4A4AFF55,$0000000000000000,$4341000000000000
  Data.q $5454F75050500C43,$5454FF545454FF54,$5353FF535354FF54,$5353FF535353FF53,$5252FF535353FF53
  Data.q $5353FF525252FF52,$5353FF525352FF53,$5353FF525252FF53,$5252FF535353FF53,$5353FF535353FF52
  Data.q $5353FF535353FF53,$5454FF535353FF53,$5353FF545454FF54,$000053484848FF53,$0000000000000000
  Data.q $0000000000000000,$5353B84949490000,$5353FF535353FF53,$5252FF525252FF53,$5151FF525252FF52
  Data.q $5151FF515252FF51,$5151FF515151FF51,$5151FF515151FF51,$5050FF515151FF51,$5151FF515252FF50
  Data.q $5151FF515151FF50,$5252FF515252FF51,$5353FF525252FF52,$4D4DFF535353FF53,$00000F454545F94D
  Data.q $0000000000000000,$0000000000000000,$51516E4545450000,$5252FF525252FF51,$5050FF515151FF52
  Data.q $5050FF505050FF50,$4F4FFF505050FF50,$B1C2FF81888EFF4F,$B7B1FFADB6D2FFA8,$8B84FFAEB29EFFB2
  Data.q $4F4FFF505050FF82,$5050FF505050FF4F,$5151FF515151FF50,$5252FF515151FF51,$4747FF525252FF52
  Data.q $000000000000BD47,$0000000000000000,$0000000000000000,$4E4E244141410000,$5050FF515151FE4E
  Data.q $4F4FFF4F4F4FFF50,$4E4EFF4F4F4FFF4F,$4E4EFF4E4E4EFF4E,$C8CFFF7C818BFF4E,$CACBFFC3C9E1FFC0
  Data.q $8597FFC8CFBEFFC2,$4E4EFF4E4E4EFF78,$4E4EFF4E4E4EFF4E,$5050FF4F4F4FFF4E,$5151FF4F4F4FFF50
  Data.q $4444FF505050FF51,$0000000000007444,$0000000000000000,$0000000000000000,$4747013D3D3D0000
  Data.q $4F4FFF4F4F4FD747,$4E4EFF4E4E4EFF4F,$4D4DFF4D4D4DFF4D,$4C4CFF4D4D4DFF4D,$D4E0FF616364FF4C
  Data.q $D5DDFFD0D6DEFFCF,$7583FFCFD7D5FFD0,$4C4CFF4C4C4CFF70,$4D4DFF4D4D4DFF4C,$4E4EFF4E4E4EFF4D
  Data.q $4F4FFF4E4E4EFF4E,$4040FF4B4B4BFF4F,$0000000000002940,$0000000000000000,$0000000000000000
  Data.q $4544000000000000,$4E4EFF4E4E4E8E44,$4C4CFF4D4D4DFF4E,$4C4CFF4C4C4CFF4C,$4B4BFF4B4B4BFF4B
  Data.q $4E4EFF4B4B4BFF4A,$4F4FFF4D4E4EFF4D,$4C4CFF4F4F4FFF4E,$4B4BFF4B4B4BFF4C,$4C4CFF4B4B4BFF4B
  Data.q $4D4DFF4C4C4CFF4C,$4E4EFF4D4D4DFF4D,$3E3EDD454545FF4E,$000000000000013E,$0000000000000000
  Data.q $0000000000000000,$4241000000000000,$4D4DFF4B4B4B4342,$4B4BFF4C4C4CFF4D,$4A4AFF4A4A4AFF4B
  Data.q $4949FF4A4A4AFF4A,$4949FF484949FF49,$4849FF484848FF49,$4949FF484848FF48,$4949FF494949FF49
  Data.q $4A4AFF494949FF49,$4C4CFF4B4B4BFF4A,$4D4DFF4C4C4CFF4C,$000093414141FF4D,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$4141000000000000,$4C4CF04848480541,$4A4AFF4B4B4BFF4C
  Data.q $4848FF494949FF4A,$4747FF484848FF48,$4747FF474747FF47,$4646FF474747FF47,$4747FF464646FF46
  Data.q $4747FF474747FF47,$4949FF484848FF47,$4A4AFF4A4A4AFF49,$4A4AFF4B4B4BFF4A,$0000473E3E3EFF4A
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$4B4BAB4646460000
  Data.q $4949FF4A4A4AFF4B,$4747FF484848FF49,$4545FF464646FF47,$4545FF454545FF45,$4545FF454545FF45
  Data.q $4545FF454545FF45,$4646FF454646FF45,$4848FF474747FF46,$4A4AFF494949FF48,$4444FF4B4B4BFF4A
  Data.q $0000073D3D3DF344,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $45465B4242420000,$4343FF454545FE45,$4141FF424242FF43,$3F3FFF404040FF41,$3E3EFF3E3E3EFF3F
  Data.q $3D3DFF3D3D3DFF3E,$3D3DFF3D3D3DFF3D,$3E3EFF3E3E3EFF3D,$4040FF3F3F3FFF3E,$4242FF414141FF40
  Data.q $3D3DFF434343FF42,$000000000000AD3D,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$2E2E000000000000,$2C2C012D2D2D012E,$2A2A012B2B2B012C,$282802292929012A
  Data.q $2727022828280228,$2727022727270227,$2626022626260227,$2626012626260226,$2727012727270126
  Data.q $2828012727270127,$0000012929290128,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$FFFF000000000000
  Data.q $FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF,$00C0070000C0FFFF,$0080030000800300
  Data.q $00C0010000C00100,$00C0030000C00300,$00E0030000E00300,$00F0070000E00700,$00F00F0000F00700
  Data.q $00F80F0000F00F00,$00F81F0000F80F00,$FFFF1F0000FC1F00,$FFFFFFFFFFFFFFFF,$FFFFFFFFFFFFFFFF
  Data.q $0000FFFFFFFFFFFF
  ;}
  
  PM_SOUND:
  IncludeBinary #INCLUDE_SOUNDFILE
    
  PM_PBLOGO: ;{
  Data.q $2020000100010000,$10A8002000010000,$0028000000160000,$0040000000200000,$0000002000010000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0100000000000000,$0000180000000303,$0000450000003E00,$0000000000001500
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000602010000,$0000310000000F00,$1612A30501006500,$0000D2000000DA54
  Data.q $00001E0000008200,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000090401000000,$0000540000002400,$3A32CE59180F8E00,$3E39FFEB5752F7B0
  Data.q $0000FFC4382CFFC8,$00008F000000E300,$0000000000002500,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0100000000000000,$00001A0000000404,$0D077B0000004400,$5047ED983027BC34,$5A5AFFE35958FFE6
  Data.q $6165FEDB5B5DFFDD,$382BFFC44240FEDE,$0000E7030201FFCD,$00002B0000009900,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000010301000000,$0000350000001200,$261DA70901006900,$5951FFD6493DE17F,$5957FFE55B55FFEF
  Data.q $5A5BFEDD5A59FFE0,$6164FFDC5E60FFDC,$4C4CFEE16970FFDC,$0705FFD0372AFFC7,$0000A4000000EB12
  Data.q $0000030000003400,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $00000B0300000100,$0000590000002800,$3F32D2621C149300,$5A50FFF75749F9BE,$5A53FFE65A51FFEB
  Data.q $5C58FFE25B54FEE3,$5D5EFFDE5C5AFFE1,$656AFFDD6063FFDD,$707BFFE0686FFFDF,$362BFFD05A5FFEE4
  Data.q $0000E9200B09FFCF,$0000270000009E00,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$100B600000000D00,$5342F0A83529C23E,$584BFFF3594AFFF4,$594FFEE7584CFFEC
  Data.q $5C55FFE65B52FEE7,$5D59FFE45D56FFE5,$5F5FFFE05D5CFFE2,$666CFFE06366FFDD,$6968FEDD757CFFE2
  Data.q $5041FFCA594FFFCF,$1511FFFF5041FFDC,$00001B0000007A40,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$3D2E000000000000,$5B49FFED503F57D3,$5746FFF55A49FFFF,$584AFEEC5747FFEE
  Data.q $5B51FFE95A4DFFEA,$5E57FFE85E55FFE8,$5E5BFFE55F59FFE6,$6A6AFEDF5D5DFFE3,$5247FFCC5C56FED7
  Data.q $4736FFDF4431FFCC,$4135BBEB4A3BFFF0,$0000130000006ACC,$000000FFFFFF0000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$5A49F3F551400000,$5948FEF35B49FFF5
  Data.q $5C4CFFED5948FFF0,$6054FFEC5D4FFFEC,$6159FFEC6258FFEC,$4F45FFD86058FEE5,$4533FFD25042FFC9
  Data.q $4937E4E74938FFE4,$000041A5342896DE,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$000000BD3B2C0000,$554413C426180000
  Data.q $5A49FEF05949FFF3,$5D4CFFED5B4AFFEF,$5E52FEF06858FFEF,$4C3DFFC44439FFDE,$5545FFE54C3CFFD7
  Data.q $02036ECE4B3BC0E6,$0000000000001603,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$4A39000000000000
  Data.q $40300000000000F5,$5A4AFFF0584852E3,$4A3FFFEF5B4BFEEF,$3E31FF6B130DFFC1,$4537C5B04F41FDA6
  Data.q $0000000000004BA0,$0000000000000000,$0000060200000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$000000FF4E3B0000,$5C4CA7E947380000,$5C50FEED5B4CFFEF,$1814FF9C2018FFEB
  Data.q $0000B8000000F33E,$0000100100004200,$0000420000002200,$0000790000006800,$0000070000004101
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$6754000000000000,$4F3F0000000000FF,$5E4FFFEE5F4EE6EE
  Data.q $2D22FEE15A51FEEC,$0000F3441914FFBC,$010098000000C000,$1C14DD63150DB914,$0000F1521D19F47B
  Data.q $000046010000BE00,$0000000000000300,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$FFFF000000000000,$00000500000000FF
  Data.q $6250FFF05948222C,$534DFEF06553FFED,$2B22FFD53325FED2,$594FFFD7483DFA93,$5656FFE3615EFFED
  Data.q $1E19FFCE3327FFCE,$0000B5000000F451,$0000010000003A00,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0F0B000000000000
  Data.q $0000320000000234,$6350DA7E201A9400,$6A5AFFF06654FFF4,$6D62FEF16A5DFEF2,$615AFFE9685EFFF1
  Data.q $6766FFDD5F5BFEE1,$3A2EFEC2504FFFE2,$0000F1331411FFD8,$00002F000000AA00,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$5A44E3DF49380000,$634EFFF7624DFFF9,$6958FFF06552FEEF,$6A5FFFF16B5CFFF1
  Data.q $615AFFEA685FFFEE,$6262FFDB5E5BFFE1,$4746FEE77173FFDC,$0A09FFE14135FEB8,$00009E000000ED19
  Data.q $0000000000002800,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$000000EC4E3D0000,$5D486DE84F410000,$604BFEEC5E49FFEE,$6755FFEC634FFFEC
  Data.q $6C5FFFEF6B5AFFEE,$6059FFEB695EFFF0,$6260FFD95C59FFE0,$7D83FFE26C6CFFDA,$463BFFB14140FEEE
  Data.q $0000DC040202FFE1,$0000110000007D00,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$6755000000000000,$53430000000000FF,$604CFFED5F4AD1EA
  Data.q $6854FFEB6450FEEA,$6E60FFF16D5BFFEE,$5D55FFEA695EFFF1,$6863FEDA5F5AFFDE,$534DFFD8645EFFDB
  Data.q $3E2EFFD7564BFFCB,$0000FFF05649FFD4,$00000D0000004200,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$1F18000000000000,$395100000000005A
  Data.q $5C48FFE85644036E,$6654FEE85E4BFFE8,$6F60FFED6A58FEE8,$635FFFE9675AFEF2,$120BFF91251DFFDC
  Data.q $4034F4862B21FE71,$312854C6493BB0A6,$3E32000000001A6B,$00000000000000B6,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $000000CE4C400000,$594453E051480000,$6753FFEB614CFFE6,$5849FFE9584BFFEE,$4A40FEDB5648FFE1
  Data.q $241AFFCB5352FFD0,$0000F02E1615FF96,$000034000000AD00,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$5A4B000000000000,$77620000000000EE,$00003AD577652EE7,$4B3F000000000700
  Data.q $342AFFBD3329D6DB,$4545FEBA3228FEBC,$1110FFC6392DFEB7,$0000AA000000F029,$0000150000004300
  Data.q $0000000000000100,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$000000FFAF8C0002,$0000000000000000
  Data.q $10140A0000000300,$2F26F8CC3F350F00,$372DFEB43027FFB4,$4237FEAA3C3AFEBB,$0000EE210E0DFFDD
  Data.q $000090000000CD00,$0000000000002700,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $00004C0000000E00,$0000880000007300,$352CBB1107079D00,$342AFFB73229FFC7,$3E37FEC13F39FFB7
  Data.q $4C42FFBB352DFEBD,$0000EA070303FFE9,$00001A0000008E00,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $3629000000000000,$2B22C88C2C2251B1,$382DFDAB3026F692,$3A30FFD83D31FFC4,$362CFEB8342BFEC1
  Data.q $342AFFB8352CFFB8,$2E27FEBE433EFFB6,$0000FFE44D43FF9B,$000077000000E000,$0000000000000F00
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$6A5C000000000000,$3129FFC7372E29E9,$352BFFBC332AFFBD,$372CFFBC362CFFBD
  Data.q $372DFFBA372CFEBB,$352CFFB8362DFFB9,$4441FFB4342BFFB7,$453CFFA32C23FEBA,$0000D4000000FEC7
  Data.q $0000080000006001,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$000000E75D500000,$362C8BDB54480000,$382EFEC3382EFFC3
  Data.q $372EFFBF382EFFC1,$372DFFBB372EFFBC,$362EFFB9372EFFBA,$332BFFB4352EFFB6,$3228FEB2423FFFB2
  Data.q $0000FA96352EFFB7,$00004A010000C600,$0000000000000300,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$1C1C000000000000,$493D0000000000FF
  Data.q $3A2EFFC3392DF0D4,$392FFFC0392FFEC1,$372FFFBC382FFFBD,$372EFFB9382EFFBB,$362EFFB5362EFFB7
  Data.q $3A36FFB2342DFFB3,$201CFFD43E32FEA5,$0000B6000000F65B,$0000000000003700,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$5C4E000000000000
  Data.q $7E6F0000000000B9,$3A2FFFCB3F3424ED,$392FFFC03A2FFEC2,$382EFFBD382EFFBE,$342CFFB9362DFFBB
  Data.q $332DFFB3342DFFB5,$3330FFAF332EFFB2,$483CFE962C27FFAE,$0000EC280E0DFFEB,$0000240000009F00
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$000000E867580000,$352B91E25E510000,$342AFEBC352BFFC0,$4036FFB8352DFEBA
  Data.q $4F4AFFC14F44FFBD,$504EFFBC4F4CFFBE,$5852FFBF5250FFBD,$4134FFCE6A63FFC4,$0908FFEC493EFFAE
  Data.q $00002F0000008F1B,$0000000000000100,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$2333000000000000,$67550000000000FF,$6958FFF16755F8EB
  Data.q $624FFFF26855FFF5,$5943E3EB5744F5F0,$6146BDED5C44D1EB,$6D5496F06A4DA9F0,$5E4C6DE9574382ED
  Data.q $483C45CF635258E7,$00000400000025BF,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$6050000000000000,$000000FF5F4500C1
  Data.q $0000080A9C9B0000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$FFFF000000000000
  Data.q $FFFFFFFFFFFFFFFF,$F0FFFF03FCFFFF87,$00FCFF0080FFFF01,$00E0FF0000F07F00,$01F0FF1F00E0FF03
  Data.q $0FF8FFFF0FF8FFFF,$00FEFF1F00FCFFFF,$00F8FF0700FCFF0F,$00FCFF0300FCFF03,$00FFFF1F00FEFF03
  Data.q $F8FFFF0FF0FFFF1F,$80FFFF01E0FFFF03,$80FFFF0080FFFF01,$E0FF3F00C0FF7F00,$F0FF1F00E0FF1F00
  Data.q $0000FFFFFFFFFF01
  ;}
  PM_HandleLogo: ;{
  Data.q $2020000100010000,$10A8002000010000,$0028000000160000,$0040000000200000,$0000002000010000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$6969050000000000,$7B7B767E7D7D316A
  Data.q $7070B07A7A7A947C,$50509B5F5E5EB270,$00004E2F2F2F8450,$0000120000002400,$0000000000000500
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$8F8F000000000000,$B0B0A19C9B9B328F
  Data.q $B9B9FFBBBABAFFB0,$ACACFFB7B6B6FFBA,$8989FF9B9B9BFFAC,$5252FF717171FF89,$000063333333BD52
  Data.q $0000060000001C00,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$AAAA429B9A9A0000
  Data.q $E3E3FFD3D2D2FFAB,$D9D9FFE0DFDFFFE3,$C8C8FFD3D2D2FFDA,$B3B3FFBEBDBDFFC9,$8888FFA8A8A8FFB3
  Data.q $3F3FFF676768FF88,$000014000000783F,$0000000000000100,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $C9C9AC9C9B9B0000,$E5E5FFE1E0E0FFCA,$DDDDFFE3E2E2FFE6,$CCCCFFD5D5D5FFDD,$B3B3FFC0C0C0FFCC
  Data.q $9D9DFFA8A7A7FFB4,$5959FF888888FF9D,$000021000000CE59,$0000000000000300,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $9191000000000000,$CBCCFF9E9D9D1392,$ECECFFE1E0E1FFCB,$DFDFFFE9E8E8FFEC,$CFCFFFD9D8D8FFE0
  Data.q $B6B6FFC3C2C2FFCF,$A1A2FFAAA9A9FFB7,$6A6AFF939395FFA0,$000042323232FF6A,$0000000000000500
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $FFFF000000000000,$9B9B02FFFFFF01FF,$C2C3FF9F9E9E239B,$F4F4FFE2E3E4FFC3,$E2E2FFF3F2F2FFF4
  Data.q $D2D2FFDCDBDBFFE3,$BBBCFFC8C8C8FFD3,$ADB0FFB2B2B3FFBB,$6D6DFF969697FFAB,$3636493E3E3EFF6D
  Data.q $0000000000000436,$0000000000000000,$0000000000000000,$76AA000000000000,$6EA2FA2C76A8953A
  Data.q $6EA2FF246EA2FF24,$6EA1FF246EA1FF24,$72A3FF266FA2FF25,$80A4FF3176A6FF2B,$EDEDFFC0C0C1FF4D
  Data.q $E9E9FFF7F7F7FFEC,$D7D7FFDFDEDEFFEA,$C4C5FFCECECEFFD8,$9E9EFFBBBEC0FFC4,$6A9BFF2C6C97FF9C
  Data.q $699BFF21699BFF21,$699BFF20699BFF20,$699BFF20699BFF20,$6B9BFF22699BFF20,$77AC723B6E9DDD37
  Data.q $B9E1FF8EC8EBF040,$BBE0FF81BDE1FF7A,$B5DCFF7DBADFFF7F,$B0D9FF6FB2DAFF71,$AAD1FF68AED9FF6A
  Data.q $CCCCFF8C8D8FFF6B,$F0F1FFEDECEDFFCD,$DEDFFFE4E5E6FFF0,$CACBFFD6D6D8FFDE,$7D80FFADADADFFC9
  Data.q $90C9FF418DBEFF7D,$93CCFF4393CAFF40,$99D3FF4C95CFFF47,$91D1FF5395D2FF57,$8CC0FF458BC8FF4C
  Data.q $79ADDB3B6E9DFF4F,$A1CDFF94CCECFF41,$A1CDFF54A1CDFF56,$9FCDFF51A0CEFF53,$9ECFFF509FCEFF4F
  Data.q $A2D0FF539FCFFF51,$8386FF6995B0FF57,$C9CAFFA6A6A8FF82,$CBCBFFCFCECFFFC9,$999BFFBABABAFFCC
  Data.q $84A7FF797A7DFF99,$89C4FF338AC5FF50,$84C3FF3087C3FF32,$7DC3FF2980C3FF2D,$75C3FF257AC3FF27
  Data.q $8FC3FF1B6FBBFF23,$7AAEF03B6E9DFF53,$A2CEFF97CDEEFF41,$A1CDFF56A1CEFF57,$A0CEFF52A1CEFF54
  Data.q $9ECFFF509FCEFF51,$A0CFFF519FCFFF50,$A0CEFF54A1D0FF53,$8493FF6593AFFF58,$7E89FF6F808CFF6E
  Data.q $86A8FF688090FF6E,$8DC7FF398DC5FF54,$89C4FF348BC5FF36,$85C3FF3187C4FF32,$7EC3FF2A81C3FF2E
  Data.q $78C3FF257CC3FF28,$91C4FF1C70BBFF24,$7BAFF03B6E9DFF54,$A2CEFF9ACEEEFF42,$A1CEFF57A1CEFF58
  Data.q $D2F3FF59B3E1FF55,$9FCFFF57B3E1FF60,$A932FFA7A480FF50,$9FD0FFA7A480FFFF,$9ECFFF519DCFFF50
  Data.q $99CCFF4D9CCFFF4F,$92C8FF4095CAFF46,$8DC7FF398FC8FF3C,$8AC5FF358CC5FF37,$87C3FF3289C4FF33
  Data.q $80C3FF2C84C3FF2F,$7AC3FF267DC3FF29,$90C3FF1D72BBFF24,$7BB0F03B6E9DFF53,$A1CFFF9CCFEFFF42
  Data.q $A1CFFF58A2CFFF59,$F4FCFF5DC7F4FF56,$9ECFFF5FD2F3FFF1,$F4FCFFFFA932FF50,$9DCFFFFFA932FFF1
  Data.q $9BCEFF4C9CCEFF4D,$98CCFF499BCEFF49,$93C9FF4296CBFF45,$8EC8FF3B90C8FF3E,$8BC5FF368DC7FF39
  Data.q $87C4FF3289C4FF34,$81C3FF2E85C3FF31,$7BC3FF277EC3FF2A,$90C3FF1D73BBFF25,$7CB1F03B6E9DFF53
  Data.q $A3CFFF9ED1EFFF43,$A2CEFF58A1CEFF5A,$C7F4FF5AB4E2FF57,$9FCFFF58B3E2FF5D,$A932FFA7A480FF50
  Data.q $9CCEFFA5A37FFFFF,$99CDFF499BCDFF4A,$98CDFF469ACEFF46,$94C9FF4296CAFF45,$8FC8FF3C91C8FF3E
  Data.q $8CC5FF378DC7FF38,$88C4FF338AC5FF35,$83C3FF2F87C3FF32,$7DC3FF287FC3FF2C,$90C3FF1D74BBFF26
  Data.q $7DB2F03B6E9DFF52,$A3D0FFA0D1EEFF43,$A3CFFF59A2CFFF5A,$A2CEFF56A2CEFF58,$A0CFFF53A1CFFF55
  Data.q $9ECFFF4F9FCFFF51,$9BCEFF4C9DCFFF4E,$99CDFF489ACDFF4B,$98CCFF4599CDFF45,$DEF5FFA2D5F1FF43
  Data.q $DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$7EC3FFA1D2EFFFB2
  Data.q $90C2FF1E75BBFF27,$7EB4F03B6E9EFF51,$A3D0FFA3D3EFFF45,$A1CFFF5AA3CFFF5B,$A2CFFF57A2CFFF59
  Data.q $A0CFFF54A1D0FF56,$9ED0FF519FCFFF51,$9CCEFF4E9DCFFF50,$9ACDFF489BCEFF4C,$99CEFF4699CEFF46
  Data.q $92D4FFB2DEF5FF44,$C5EEFF22B2E7FF1C,$F7FBFF5FD2F1FF3A,$6FBBFF1B6FBBFFF1,$6FBBFF1B6FBBFF1B
  Data.q $7FC3FFB2DEF5FF1B,$91C2FF1E76BBFF28,$80B5F03C6F9EFF52,$AAD5FFA8D7F3FF46,$A2CFFF5BA6D2FF5E
  Data.q $D2E7FF5BA4D0FF59,$FFFFFFE3F0F7FFAB,$D0E7FFE3F0F7FFFF,$9DCFFF52A0D0FFA8,$9ACDFF4A9CCEFF4C
  Data.q $9ACEFF479BCFFF47,$92D4FFB2DEF5FF45,$C5EEFF22B2E7FF1C,$F7FBFF5FD2F1FF3A,$6FBBFF1B6FBBFFF1
  Data.q $6FBBFF1B6FBBFF1B,$81C3FFB2DEF5FF1B,$92C2FF1F78BBFF29,$81B6F03C6F9FFF52,$AED8FFAAD8F4FF46
  Data.q $ADD8FF63ACD9FF62,$E0EFFFDEEDF6FF66,$A5CFFF7DB7DAFFC5,$E0EFFF79B5DAFF59,$A2D1FFDCECF6FFC4
  Data.q $9BCEFF4C9CCEFF56,$9ACFFF489CCFFF48,$DEF5FFA2D6F1FF47,$DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2
  Data.q $DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$83C3FFA2D3EFFFB2,$93C2FF207ABBFF2C,$81B7F03C709FFF53
  Data.q $ADD8FFACD9F4FF47,$D9EFFF62AFDAFF62,$ACDAFFB4D9EEFFB4,$A4D0FF5BA6D4FF60,$A1CFFF52A1D0FF55
  Data.q $D1E8FFC0DEEEFF54,$9CCEFF4C9DCEFFA9,$9CCFFF499CCFFF4A,$98CCFF459ACEFF48,$93CAFF4194CBFF43
  Data.q $8FC7FF3B92C8FF3E,$8CC7FF388DC5FF39,$89C4FF338AC5FF35,$84C3FF3087C3FF32,$93C2FF207ABBFF2D
  Data.q $82B7F03D70A0FF53,$AED9FFAEDAF4FF47,$F5FBFF63AFDAFF62,$AFDFFF5FA9D8FFEB,$ADDCFF64B1E0FF62
  Data.q $A2D2FF5AA8D6FF5F,$F3F9FF71B1D8FF54,$9CCEFF4D9DCFFFE8,$9CD0FF4A9DCFFF4B,$97CEFF479ACFFF48
  Data.q $94CAFF4296CBFF44,$90C8FF3D92C9FF3F,$8DC7FF388FC8FF3A,$8AC4FF348BC5FF36,$86C3FF3188C4FF32
  Data.q $94C2FF217BBBFF2E,$82B8F03D71A1FF54,$ADD8FFB0DCF4FF47,$FDFEFF64AFDAFF63,$B0DEFF489AD0FFFB
  Data.q $A53CFF6AB0D8FF63,$AA99FFDEA545FFE7,$FDFEFF63AFDCFF97,$9ECFFF51A2D3FFFB,$9DD0FF4C9DD0FF4D
  Data.q $DEF5FFA2D6F1FF4A,$DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2
  Data.q $87C3FFA2D3EFFFB2,$95C3FF247DBBFF30,$83B8F03E71A1FF55,$AED8FFB2DDF4FF48,$F5FBFF63B0DAFF64
  Data.q $AADAFF57A3D5FFEB,$A93AFF6EB0D5FF5C,$A32BFFF6A62DFFF1,$B658FFF2A42DFFF2,$A9DBFF8EB3BBFFF4
  Data.q $A6D9FF55A8DBFF58,$92D4FFB2DEF5FF51,$B6E9FF1DA6E1FF1C,$CEF0FF34C2EDFF25,$6FBBFFF6FDFFFF4F
  Data.q $6FBBFF1B6FBBFF1B,$88C4FFB2DEF5FF1B,$96C2FF247EBBFF31,$83B9F03E72A2FF55,$AEDAFFB2DDF4FF48
  Data.q $D4ECFF64AFDAFF64,$A2D4FF9ACAE6FFA6,$AB3DFF65AACFFF52,$AF34FFFEB938FFF1,$A42BFFF9A72FFFFE
  Data.q $ADDFFFDCAC58FFF3,$ADE1FF59AEE0FF5A,$92D4FFB2DEF5FF59,$B6E9FF1DA6E1FF1C,$CEF0FF34C2EDFF25
  Data.q $6FBBFFF6FDFFFF4F,$6FBBFF1B6FBBFF1B,$91CEFFB2DEF5FF1B,$9DCBFF2B88C4FF39,$83B9F03F73A3FF5D
  Data.q $AFD9FFB4DFF4FF48,$B1DDFF64B0DAFF64,$CAE7FFD2E9F6FF66,$AA3CFF64A5CBFF9C,$BB38FFFFC13AFFF0
  Data.q $B450FFFFAC34FFFF,$ADDFFF61AFDDFFF8,$AEE2FF5BADE1FF5C,$DEF5FFA4D8F3FF5B,$DEF5FFB2DEF5FFB2
  Data.q $DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$DEF5FFB2DEF5FFB2,$97D5FFA4D5F1FFB2,$A2D0FF318CCCFF3E
  Data.q $83B9F03F73A4FF60,$AED9FFB4DFF4FF48,$B1DDFF64B0DAFF64,$D3EDFF65B3DEFF65,$AC3DFFDCE8EAFFA6
  Data.q $BE39FFFFBD39FFF5,$B7C8FFFAB54BFFFF,$ADDFFF5DAEDEFF8A,$AFE2FF5DAEE0FF5C,$ACE0FF5AAEE2FF5C
  Data.q $A8DEFF53A9DFFF56,$A2DAFF4FA5DCFF51,$9FD9FF49A1DAFF4C,$9BD7FF449DD8FF47,$98D6FF419AD6FF43
  Data.q $A3CFFF318FCCFF3F,$83B9F04074A5FF61,$AED9FFB4DFF4FF48,$B2DCFF65B0DAFF64,$B3E0FF66B2DEFF66
  Data.q $AA3CFF6FB2D6FF66,$C28BFFF8BA57FFF1,$B0DFFF76B5D5FFDE,$ADDFFF5EAEDFFF60,$B0E3FF5EAFE1FF5C
  Data.q $ADE1FF5CAFE2FF5E,$A9DEFF55ABE0FF58,$A3DBFF4FA6DCFF52,$A0DAFF4AA2DBFF4D,$9CD8FF459ED9FF48
  Data.q $99D6FF429AD7FF44,$A3D0FF318FCCFF40,$83B9F04075A6FF63,$AFD8FFB5DFF4FF48,$B1DDFF64B0DAFF63
  Data.q $B4DFFF66B3DFFF66,$B2DFFF67B2E0FF66,$B1E0FF65B1DFFF66,$B0DFFF62B1E0FF63,$AEDEFF5EAEDEFF60
  Data.q $B1E3FF5FB0E2FF5D,$AEE2FF5DB0E3FF60,$A9DFFF56ACE0FF5A,$A4DCFF50A8DEFF53,$A1DAFF4CA2DAFF4E
  Data.q $9DD8FF469FD9FF49,$9AD6FF439BD7FF44,$A5D1FF3290CDFF41,$8CBEF04176A7FF63,$DEF3FFAED7EEEB53
  Data.q $DEF4FFB7DFF4FFB7,$DFF4FFB9DEF3FFB8,$DEF4FFB6DEF5FFB8,$DBF3FFB3DDF4FFB5,$D9F1FFAFDAF1FFB1
  Data.q $D6EFFFAAD7F0FFAD,$D3EFFFA5D4EFFFA7,$D1EEFFA0D1EEFFA2,$CDEDFF99D0EDFF9C,$CAEBFF94CCECFF97
  Data.q $C5EAFF8EC7EBFF90,$C2EAFF89C3EAFF8B,$C0E9FF84C1EAFF86,$8FBEFF5DA7DAFF81,$86BBDB4176A8FF45
  Data.q $86BBEA4C86BB814C,$86BBFF4C86BBFF4C,$86BBFF4C86BBFF4C,$85BAFF4C86BBFF4C,$85B9FF4B85BAFF4C
  Data.q $84B8FF4B84B9FF4B,$83B7FF4A83B8FF4A,$82B5FF4982B6FF4A,$80B4FF4881B5FF49,$7FB2FF4880B3FF48
  Data.q $7EB1FF477EB1FF47,$7CAFFF467DB0FF46,$7BADFF457BAEFF45,$79ABFF447AACFF44,$78A9FF4379AAFF43
  Data.q $0000724277A9DB42,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$E0FF000000000000
  Data.q $80FFFF00C0FFFF01,$00FF7F0080FF7F00,$00007F0000FC7F00,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000,$0000000000000000
  Data.q $0000000000000000,$0000000000000000,$0000000000000000,$FFFF000000000000,$FFFFFFFFFFFFFFFF
  Data.q $0000FFFFFFFFFFFF
  ;}
EndDataSection
;
Main()



; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 25
; Folding = AAgAQAwHw
; EnableThread
; EnableXP
; UseIcon = PureMonitor.ico
; CompileSourceDirectory
; EnableCompileCount = 11
; EnableBuildCount = 0